unit dllguiunit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, StdCtrls, dllguiunit2, fndllgui;

type

  { TGuiForm1 }

  TGuiForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var CloseAction: TCloseAction);
  private
    { private declarations }
  public
    { public declarations }
    IsModal: Boolean; // Required for postmdal function.
  end; 

var
  GuiForm1: TGuiForm1;

implementation

{$R *.lfm}

{ TGuiForm1 }

procedure TGuiForm1.Button1Click(Sender: TObject);
begin
  OFnDllGui.PreModal();
  ShowMessage('Hello from Dll');
  OFnDllGui.PostModal(Self.IsModal);
end;

// This is a sample of creating a form from another dll form
// to be shown as modal.
procedure TGuiForm1.Button2Click(Sender: TObject);
begin
  If not Assigned(GuiForm2) then
  begin
    GuiForm2:= TGuiForm2.Create(Self);
  end;
  GuiForm2.IsModal:= True;
  OFnDllGui.PreModal();
  GuiForm2.ShowModal();
  GuiForm2.Free;
  GuiForm2:= nil;
  OFnDllGui.PostModal(Self.IsModal);
end;

// This is a sample of creating a form from another dll form
// to be shown as no modal.
procedure TGuiForm1.Button3Click(Sender: TObject);
begin
  If not Assigned(GuiForm2) then
  begin
    GuiForm2:= TGuiForm2.Create(Self);
  end;
  GuiForm2.IsModal:= False;
  GuiForm2.Show();
end;

// Close function. Deleting forms created from this form and
// restoring enabled property of main form.
procedure TGuiForm1.FormClose(Sender: TObject; var CloseAction: TCloseAction);
begin
  If (Assigned(GuiForm2)) then
  begin
    GuiForm2.Close;
    GuiForm2.Free;
    GuiForm2:= nil;
  end;
  OFnDllGui.RestoreOwnerEnabled();
end;

end.

