unit fndllgui;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Forms;

type

  { TFnDllGui }

  TFnDllGui = class
    Owner: TForm; // The main form.
    OwnerEnabled: Boolean; // Original main form enabled property.
    procedure PreModal();
    procedure PostModal(IsModal: Boolean);
    procedure RestoreOwnerEnabled();
  end;

var
  OFnDllGui: TFnDllGui;

implementation

// Function to be called before a form is shown as modal (include message boxes).
procedure TFnDllGui.PreModal();
begin
  If Assigned(Owner) and OwnerEnabled then
  begin
    Owner.Enabled:= False;
  end;
end;

// Function to be called before a form shown as modal (include message boxes)
// is closed and control returns.
procedure TFnDllGui.PostModal(IsModal: Boolean);
begin
  If (not IsModal) then
  begin
    Owner.Enabled:= OwnerEnabled;
  end;
end;

// Function that restores enabled property of main form. It has to be
// called on close events in forms in dll.
procedure TFnDllGui.RestoreOwnerEnabled();
begin
  Owner.Enabled:= OwnerEnabled;
end;

end.

